unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, MCDPlayer, Gauges;

type
  TForm1 = class(TForm)
    lb: TListBox;
    CDPlayer1: TCDPlayer;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button5: TButton;
    Button6: TButton;
    Button8: TButton;
    ComboBox1: TComboBox;
    StatusBar1: TStatusBar;
    Gauge: TGauge;
    Timer1: TTimer;
    tb: TTrackBar;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    lbn: TListBox;
    procedure CDPlayer1AfterInsert(Sender: TObject;
      FirstDriveLetter: Char);
    procedure CDPlayer1AfterRemove(Sender: TObject;
      FirstDriveLetter: Char);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure tbChange(Sender: TObject);
    procedure CDPlayer1Notify(Sender: TObject; NotifyValue: TNotifyValues);
    procedure lbDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    procedure RefreshDisplay;
  end;

var
  Form1: TForm1;

implementation


{$R *.DFM}


procedure TForm1.CDPlayer1AfterInsert(Sender: TObject;
  FirstDriveLetter: Char);
var
  i: integer;
  dl: Longint;
begin
  with lb.Items, CDPlayer1 do begin
    Clear;
    if IsAudioCD then begin
      label4.Caption:=Artist+' - '+Album+' (SN: '+IntToHex(StrToInt(SerialNumber),6)+')';
      label2.Caption:=Format('Track 1 of %d',[tracks]);
      for i:=0 to tracks-1 do
        Add(Format('%2d. %-45s %2.2d:%2.2d   %2.2d:%2.2d',
                   [i+1,TOC[i].Title,
                   TOC[i].LenMin,TOC[i].LenSec,
                   TOC[i].StartMin,TOC[i].StartSec]));
      dl:=Length;
      statusbar1.panels[0].Text:=Format('Total playtime: %2.2d:%2.2d',[TMSF(dl).Minutes,TMSF(dl).Seconds]);
      tb.max:=getcurrenttrackleninms;
      gauge.MaxValue:=GetLengthInMS;
    end;
  end;
end;

procedure TForm1.CDPlayer1AfterRemove(Sender: TObject;
  FirstDriveLetter: Char);
begin
  lb.Items.clear;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  cdplayer1.play;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  cdplayer1.stop;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  cdplayer1.pause;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  with cdplayer1 do begin
    Next;
    if mode<>mpplaying then
      RefreshDisplay;
  end;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  with cdplayer1 do begin
    prior;
    if mode<>mpplaying then
      RefreshDisplay;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  with cdplayer1 do begin
    Application.title:=about;
    Caption:=about;
    Init;
    CDPlayer1AfterInsert(nil,currentdrive);
    combobox1.ItemIndex:=integer(displayTimeMode);
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  with cdplayer1 do
    if mode=mpplaying then
      refreshdisplay;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  with cdplayer1 do begin
    displayTimeMode:=TDisplayTimeFormats(combobox1.ItemIndex);
    if mode<>mpplaying then
      RefreshDisplay;
  end;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  cdplayer1.opendoor;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  cdplayer1.deinit;
end;

procedure TForm1.tbChange(Sender: TObject);
var
  m: tmodes;
begin
  with cdplayer1 do
    try
      m:=mode;
      SetCurrentTrackPosInMS(tb.position);
      if m=mpplaying then
        play;
    except
    end;
end;

procedure TForm1.CDPlayer1Notify(Sender: TObject;
  NotifyValue: TNotifyValues);
var
  s: string;
begin
  case NotifyValue of
    nvSuccessful: s:='Successful';
    nvSuperseded: s:='Superseded';
    nvAborted: s:='Aborted';
    nvFailure: s:='Successful';
  end;
  lbn.Items.Insert(0,timetostr(now)+': '+s);
end;

procedure TForm1.lbDblClick(Sender: TObject);
var
  m: tmodes;
begin
  with cdplayer1 do begin
    m:=mode;
    gototrack(lb.ItemIndex+1);
    if m=mpplaying then
      play
    else
      RefreshDisplay;
  end;
end;

procedure TForm1.RefreshDisplay;
var
  dt: TDisplayTime;
begin
  with cdplayer1 do begin
    dt:=displaytime;
    label1.Caption:=Format('%s: %2.2d:%2.2d',[combobox1.Text,dt.min,dt.sec]);
    label2.Caption:='Track: '+IntToStr(CurrentTrack)+' of '+inttostr(Tracks);
    tb.OnChange:=nil;
    tb.max:=getcurrenttrackleninms;
    tb.Position:=getcurrenttrackposinms;
    tb.OnChange:=tbchange;
    gauge.Progress:=GetPosInMS;
  end;
end;

end.

